<?php

/**
 * Klasse General
 * Zeigt algemeine Einstellungen von der isgw.conf Datei
 */
class General {
    /*
     * Funktion display erzeugt den Inhalt von der HTML-Seite
     */

    function display($args) {
        require_once ('./includes/isgwtelnet.php');
        // args
        $m = $_GET['m'];

        include('./includes/header.php');
        $general_table = $this->dynamic_table();
        // build page content
        $ret .= $general_table;
        $ret.='<script>
                    $("#logging").validate({
                    rules: {
                            port: {
                                digits: true,
                                range: [1,65535],
                            },
                    }
                });
                    $("#cifs").validate({
                    rules: {
                            cifs_log_share: {
                                required: "#cifs_log_enabled:checked",
                                sharePath: "#cifs_log_enabled:checked",
                            },
                            cifs_log_user: {
                                required: "#cifs_log_enabled:checked",
                            },
                            cifs_log_password: {
                                required: "#cifs_log_enabled:checked",
                            },
                    }
                });
                    </script>';
        //Rückgabe: Inhalt der HTML-Seite
        return $ret;
    }

    /*
     * Der reguläre Ausdruck, der in der Datenbank gespeichert ist wird zurückgegeben
     * und nachher angezeigt.
     */

    /*
     * Die Adresse von dem Loging Server, die in der Datenbank gespeichert ist wird zurückgegeben
     * und nachher angezeigt.
     */

    function address() {
        $ba = new beroAri();
        $query = $ba->select("select logserver from general");
        while ($entry = $ba->fetch_array($query)) {
            $ret = split(":", $entry['logserver']);
            return $ret[0];
        }
    }

    /*
     * Syslog select box wird, mit den in der Datenbank gespeicherten Daten, erzeugt
     * und nachher angezeigt.
     */

    function syslog() {
        $ba = new beroAri();
        $option = $ba->get("syslog_facility");
        $sel = "<select name='syslog_facility'>";
        $j = 0;
        for ($i = 16; $i <= 23; $i++) {
            if ($option == $i)
                $sel.='<option value=\'' . $i . '\' selected>' . $i . ' - local ' . $j++ . '</option>';
            else
                $sel.='<option value=\'' . $i . '\'>' . $i . ' - local ' . $j++ . '</option>';
        }
        $sel.="</select>";
        return $sel;
    }

    /*
     * Das Loglevel für Debuggingmode, das in der Datenbank gespeichert ist wird zurückgegeben
     * und nachher angezeigt.
     */

    function loglevel() {
        $ba = new beroAri();
        $query = $ba->select("select loglevel from general");
        $ret.="<select name='loglevel' onmouseover=\"Tip('" . GENERAL_LOGLEVEL . "')\" onmouseout='UnTip()'>";
        while ($entry = $ba->fetch_array($query)) {
            for ($i = 0; $i <= 9; $i++) {
                if ($i == $entry['loglevel']) {
                    $ret.="<option value='$i' selected>$i</option>";
                } else {
                    $ret.="<option value='$i'>$i</option>";
                }
            }
        }
        $ret.="</select>";
        return $ret;
    }

    /*
     * Das Port von dem Loging Server, das in der Datenbank gespeichert ist wird zurückgegeben
     * und nachher angezeigt.
     */

    function port() {
        $ba = new beroAri();
        $query = $ba->select("select logserver from general");
        while ($entry = $ba->fetch_array($query)) {
            $ret = split(":", $entry['logserver']);
            return $ret[1];
        }
    }

    /*
     * Der boolesche Wert von Loging Active, der in der Datenbank gespeichert ist wird zurückgegeben
     * in der Form eines Checkboxs und nachher angezeigt.
     */

    function active() {
        $ba = new beroAri();
        $query = $ba->select("select logging_active from general");
        while ($entry = $ba->fetch_array($query)) {
            if ($entry['logging_active'] == "1") {
                return "<input type='checkbox' name='active' value='1' onmouseover=\"Tip('" . GENERAL_ACTIVE . "')\" onmouseout='UnTip()' checked>";
            } else {
                return "<input type='checkbox' name='active' value='1' onmouseover=\"Tip('" . GENERAL_ACTIVE . "')\" onmouseout='UnTip()'>";
            }
        }
    }

    /*
     * Der boolesche Wert von cifs enable, der in der Datenbank gespeichert ist wird zurückgegeben
     * in der Form eines Checkboxs und nachher angezeigt.
     */

    function cifs_enabled($bc) {
        $cifs_enabled = $bc->get("root", "cifs_log_enabled");
        if ($cifs_enabled == "1") {
            return "<input type='hidden' name='cifs_log_enabled' name='cifs_log_enabled' value='0'>"
                    . "<input type='checkbox' name='cifs_log_enabled' id='cifs_log_enabled' value='1'  checked>";
        } else {
            return "<input type='hidden' name='cifs_log_enabled' value='0'>"
                    . "<input type='checkbox' name='cifs_log_enabled' id='cifs_log_enabled' value='1'>";
        }
    }

    /*
     * Der boolesche Wert von System, der in der root BD gespeichert ist wird zurückgegeben
     * in der Form eines Checkboxs und nachher angezeigt.
     */

    function systemLog($bc) {
        $sysLog = $bc->get("root", "system-check-enabled");
        if ($sysLog == "1") {
            return "<input type='hidden' name='system-check-enabled' value='0'><input type='checkbox' name='system-check-enabled' value='1' checked>";
        } else {
            return "<input type='hidden' name='system-check-enabled' value='0'><input type='checkbox' name='system-check-enabled' value='1'>";
        }
    }

    //Änderungen des logging forms speichern
    private function _save_logging($bc) {
        $ba = new beroAri();


        if (($_POST['address'] != "") && ($_POST['port'] != "")) {
            $isgw = new isgwtelnet();
            $isgw->isgw_login();
            $isgw->logserver($_POST['address'], $_POST['port']);
            $query = $ba->update("update general set logserver='" . sqlite_escape_string($_POST['address'] . ":" . $_POST['port']) . "'");
        }

        if ($_POST['loglevel'] != "") {
            $isgw = new isgwtelnet();
            $isgw->isgw_login();
            $isgw->loglevel_message($_POST['loglevel']);
            $query = $ba->update("update general set loglevel='" . sqlite_escape_string($_POST['loglevel']) . "'");
        }

        if ($_POST['active'] == "1") {
            $isgw = new isgwtelnet();
            $isgw->isgw_login();
            $isgw->logactive_message(1);
            $query = $ba->update("update general set logging_active='" . sqlite_escape_string($_POST['active']) . "'");
        } else {

            $isgw = new isgwtelnet();
            $isgw->isgw_login();
            $isgw->logactive_message(0);
            $isgw->loglevel_message();
            $ba->update("update general set loglevel='0'");
            $ba->update("update general set logging_active='0'");
        }

        if (isset($_POST['syslog_facility']) || isset($_POST['system-check-enabled'])) {
            //Nur wenn syslog facility verändert wurde, ist ein oranges activate erforderlich
            if ($ba->get('syslog_facility') != $_POST['syslog_facility'] || $bc->get("root", 'system-check-enabled') != $_POST['system-check-enabled']) {
                $table.=Helper::activate(2, true, 'gen', ACTIVATE);
            }
            $ba->set("syslog_facility", $_POST['syslog_facility']);
            $bc->set("root", "system-check-enabled", $_POST['system-check-enabled']);
        } else {
            $ba->set("syslog_facility", "16");
            $table.=Helper::activate(2, true, 'gen', ACTIVATE);
        }

        $table.=Helper::activate(1, true, 'gen', ACTIVATE);
        return $table;
    }

    //Änderungen des cifs forms speichern
    private function _save_cifs($bc) {

        $bc->set('root', 'cifs_log_enabled', $_POST['cifs_log_enabled']);
        $bc->set('root', 'cifs_log_share', sqlite_escape_string($_POST['cifs_log_share']));
        $bc->set('root', 'cifs_log_user', $_POST['cifs_log_user']);
        $bc->set('root', 'cifs_log_password', $_POST['cifs_log_password']);
        $bc->set('root', 'cifs_log_domain', $_POST['cifs_log_domain']);
	$bc->set('root', 'cifs_log_size', $_POST['cifs_log_size']);
	$bc->set('root', 'isgw_log_size', ($_POST['cifs_log_size'] * 0.3 * 1000 / 2));

	@exec('/etc/init.d/S41logcifsmount stop');

        return Helper::activate(3, true, 'gen', ACTIVATE);
    }

    /*
     * Funktion dynamic_table
     */

    function dynamic_table() {
        require_once('/usr/fallback/beroConf.php');
        $bc = new beroConf('root');
        //Logging Änderungen speichern
        if (isset($_POST['address']) || isset($_POST['ports']) || isset($_POST['syslog_facility']))
            $table.=$this->_save_logging($bc);

        //CIFS Änderungen speichern
        if (isset($_POST['cifs_log_enabled']))
            $table.=$this->_save_cifs($bc);

        require_once("./includes/lang.php");
        $table .= "<form class='extensions_form' name='logging' id='logging' action='' method='POST'>
        <input type=hidden name=m value='" . $m . "'>
        <input type=hidden name=a value='save'>
        <br>
        <table class='contenttoc' id='table'>
        <tr>
        <th colspan='2'>" . LOGGING_TABLE_HEADER_DIS . "</th>
        </tr>
        <tr>
        <td><b>" . LOGGING_SERVER_DIS . ":</b></td>
        <td><input type='text' name='address' value='" . $this->address() . "' onmouseover=\"Tip('" . GENERAL_ADDRESS . "')\" onmouseout='UnTip()'></td>
        </tr>
        <tr>
        <td><b>" . LOGGING_SERVER_PORT_DIS . ":</b></td>
        <td><input type='text' name='port' value='" . $this->port() . "' onmouseover=\"Tip('" . GENERAL_PORT . "')\" onmouseout='UnTip()'></td>
        </tr>
        <tr>
        <td><b>" . LOGGING_ACTVIVE_DIS . ":</b></td>
        <td>" . $this->active() . "</td>
        </tr>
        <tr>
        <td><b>" . LOGGING_LOG_LEVEL_DIS . ":</b></td>
        <td>" . $this->loglevel() . "</td>
        </tr>
        <tr>
        <td><b>" . LOGGING_SYSTEM_LOG_DIS . ":</b></td>
        <td>" . $this->systemLog($bc) . "</td>
        </tr>
        <!--
        <tr>
        <td><b>MSP Device IP:</b></td>
        <td><input type='text' name='msp' value='";
        //. $this->msp_device_ip() .
        $table.="' disabled='true' onmouseover=\"Tip('" . GENERAL_MSP . "')\" onmouseout='UnTip()'></td>
        </tr>
        -->
        <tr>
        <td><b>" . LOGGING_SYSLOG_DIS . ":</b></td>
        <td>" . $this->syslog() . "</td>
        </tr>
        <tr>
        <td colspan='2'><input name='submit' type='submit' value='" . BUTTON_SAVE . "' onmouseover=\"Tip('" . GENERAL_SAVE . "')\" onmouseout='UnTip()'>
        </td>
        </tr>
        </table>
        <br>
        </form>";

        if ($bc->get("root", "cifs_log_enabled")) {
            exec("/bin/mount", $res);
            $mount = implode(" ", $res);
            if (strpos($mount, "/var/log") !== false) {
                $testButton = '<input type=\'button\' id=\'test\' value=\'Test CIFS share\'>'
                        . '<script>$("#test").click(function() {
                $.ajax({url:"misc/testCifs.php",success:function(result){
                    $(".testRes").html(result);
                }});
                });
                    </script>';
                $img = "<img src='./includes/images/punkt_gruen.gif'>";
            } else
                $img = "<img src='./includes/images/punkt_rot.gif'>";
            $state = "<tr>"
                    . "<td><b>" . LOGGING_CIFS_STATUS_DIS . "</b></td>"
                    . "<td>" . $img . "</td>"
                    . "</tr>";
        }
        //CIFS Share
        $table .= "<div class='testRes center'></div><form class='extensions_form' name='cifs' id='cifs' action='' method='POST'>
        <input type=hidden name=m value='" . $m . "'>
        <input type=hidden name=a value='save'>
        <br>
        <table class='contenttoc' id='table'>
        <tr>
        <th colspan='2'>" . LOGGING_CIFS_TABLE_HEADER_DIS . "</th>
        </tr>"
                . $state .
                "<tr>
        <td><b>" . LOGGING_CIFS_ENABLED_DIS . ":</b></td>
        <td>" . $this->cifs_enabled($bc) . "</td>
        </tr>
        <tr>
        <tr>
        <td><b>" . LOGGING_CIFS_SHARE_DIS . ":</b></td>
        <td><input type='text' name='cifs_log_share' value='" . stripslashes($bc->get("root", "cifs_log_share")) . "' ></td>
        </tr>
        <tr>
        <td><b>" . LOGGING_CIFS_USER_DIS . ":</b></td>
        <td><input type='text' name='cifs_log_user' value='" . $bc->get("root", "cifs_log_user") . "'></td>
        </tr>
        <tr>
        <td><b>" . LOGGING_CIFS_PASSWORD_DIS . ":</b></td>
        <td><input type='password' name='cifs_log_password' value='" . $bc->get("root", "cifs_log_password") . "'></td>
        </tr>
        <tr>
        <td><b>" . LOGGING_CIFS_DOMAIN_DIS . ":</b></td>
        <td><input type='text' name='cifs_log_domain' value='" . $bc->get("root", "cifs_log_domain") . "'></td>
        </tr>
        <tr>
        <td><b>" . LOGGING_CIFS_SIZE_DIS . ":</b></td>
        <td><input type='text' name='cifs_log_size' value='" . (($bc->get('root', 'cifs_log_size') != '') ? '5000' : $bc->get('root', 'cifs_log_size')) . "'></td>
        </tr>
        <tr>
        <td colspan='2'><input name='submit' type='submit' value='" . BUTTON_SAVE . "' onmouseover=\"Tip('" . GENERAL_SAVE . "')\" onmouseout='UnTip()'>"
                . $testButton . "
        </td>
        </tr>
        </table>
        <br>
        </form>";
        //Rückgabe: Erzeugte Tabelle mit den änderbaren Feldern von den Einstellungen von isgw.conf
        return $table;
    }

}

?>
